#ifndef HIDCONTROLLER_H
#define HIDCONTROLLER_H
#include "hidcontrollerbase.h"
#include <qwidget.h>
#include <qlineedit.h>
#include <stdio.h>
#include <qframe.h>
#include <qslider.h>
#include <qvaluelist.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qpushbutton.h>

typedef struct KeyData
{
	int qkey;
	int ukey;
} KeyData;

class hidcontroller : public hidcontrollerbase
{ 
	Q_OBJECT

 public:
	hidcontroller( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	~hidcontroller();


 private:
   	void keyPressEvent(QKeyEvent *e)   { QueueKey(e, 1); }
	void keyReleaseEvent(QKeyEvent *e) { QueueKey(e, 0); }
	void QueueKey(QKeyEvent *e, int pressed);
	void closeEvent(QCloseEvent*);
	void mousePressEvent(QMouseEvent*);
	void mouseMoveEvent(QMouseEvent*);

	void toggleSuspend(bool);

 protected:
	
	QMenuBar *menuBar;
	QPopupMenu *debug;
	int idDebug;
	QPopupMenu *options;
	int idKeyMode, idTextMode, idComMode;

	FILE *fp;
	bool closeApp;
	bool isKHloaded;

	int x,y;
	unsigned char mouseButton;
	bool mouseNotValid;

        QValueList<KeyData> convKey;
	QValueList<int> sendData;
	unsigned char modify;

	int intervalSuspend;
	int intervalLightOff;
	int intervalDim;

 private slots:
	void sliderchange(int);
	void moduleLoad();
	void moduleUnload();
	void keyLock();
	void keyUnlock();
	void closeClicked();
	void textSend();

	void mouseLClicked();
	void mouseRClicked();
	void mouseLDraged(bool);
	void mouseRDraged(bool);

	void setDebug();
	void sendKeyMode();
	void sendTextMode();
	void sendComMode();

};

#endif // HIDCONTROLLER_H

